// MazeGeneratorListener.java
//
// ICS 23 Project #1: Dark at the End of the Tunnel
// Coded by Alex Thornton Fall 2002
// Minor edits by Norman Jacobson January 2003


// The MazeGeneratorListener defines a set of notification methods that
// are to be called while a maze is being generated.

/**
 * Describes all applicable functions to animators of maze generators.
 */
public interface MazeGeneratorListener
{
	// startingMazeGeneration() is called right after the initial maze
	// has been created. This tells the listener that maze generation
	// is about to begin and allows it to display the initial maze.
	/**
	 * Notifies the animator that a new generation of a maze is about to begin.
	 * @param maze the maze in its current state (after field creation)
	 */
	public void startingMazeGeneration(Maze maze);

	// mazeModified() is called every time a step is taken towards
	// generating the completed maze; thus, the GUI can be updated with
	// each maze change (if animation is on).
	// The parameter is the maze being generated.
	/**
	 * Notifies the animator that a change has been made in the field of the maze being generated.
	 * @param maze the maze being generated
	 */
	public void mazeModified(Maze maze);
}
